;; Garfield
; VIB
;

;-| Special Motions |------------------------------------------------------
[Command]
name = "upper_x"
command = ~F, D, DF, x

[Command]
name = "upper_y"
command = ~F, D, DF, y

[Command]
name = "upper_xy"
command = ~F, D, DF, x+y

[Command]
name = "QCF_x"
command = ~D, DF, F, x

[Command]
name = "QCF_y"
command = ~D, DF, F, y

[Command]
name = "QCF_z"
command = ~D, DF, F, z

[Command]
name = "QCF_xy"
command = ~D, DF, F, x+y

[Command]
name = "QCB_a"
command = ~D, DF, F, a

[Command]
name = "QCB_b"
command = ~D, DF, F, b

[Command]
name = "FF_ab"
command = F, F, a+b

[Command]
name = "FF_a"
command = F, F, a

[Command]
name = "FF_b"
command = F, F, b

;-| Double Tap |-----------------------------------------------------------
[Command]
name = "FF"     ;Required (do not remove)
command = F, F
time = 10

[Command]
name = "BB"     ;Required (do not remove)
command = B, B
time = 10

;-| 2/3 Button Combination |-----------------------------------------------
[Command]
name = "recovery";Required (do not remove)
command = x+y
time = 1

;-| Dir + Button |---------------------------------------------------------
[Command]
name = "down_a"
command = /$D,a
time = 1

[Command]
name = "down_b"
command = /$D,b
time = 1

;-| Single Button |---------------------------------------------------------
[Command]
name = "up"
command = U
time = 1

[Command]
name = "up"
command = UB
time = 1

[Command]
name = "up"
command = UF
time = 1

[Command]
name = "a"
command = a
time = 1

[Command]
name = "b"
command = b
time = 1

[Command]
name = "c"
command = c
time = 1

[Command]
name = "x"
command = x
time = 1

[Command]
name = "y"
command = y
time = 1

[Command]
name = "z"
command = z
time = 1

[Command]
name = "start"
command = s
time = 1

;-| Hold Dir |--------------------------------------------------------------
[Command]
name = "holdfwd";Required (do not remove)
command = /$F
time = 1

[Command]
name = "holdback";Required (do not remove)
command = /$B
time = 1

[Command]
name = "holdup" ;Required (do not remove)
command = /$U
time = 1

[Command]
name = "holddown";Required (do not remove)
command = /$D
time = 1

[Statedef -1]

;===========================================================================
;---------------------------------------------------------------------------
;Plasma Blade
[State -1, Plasma Blade]
type = ChangeState
value = 1000
triggerall = !IsHelper
triggerall = statetype != A
triggerall = stateno != 100
triggerall = !NumProjID(9000)
triggerall = command = "QCF_x" || command = "QCF_y" || command = "QCF_z"
triggerall = (Var(40):=(command = "QCF_x")*1) || (Var(40):=(command = "QCF_y")*2) || (Var(40):=(command = "QCF_z")*3)
trigger1 = ctrl
trigger2 = StateNo = 200
trigger2 = PrevStateno != 100
trigger2 = MoveHit
trigger3 = StateNo = 210
trigger3 = MoveHit
trigger4 = StateNo = 230
trigger4 = MoveHit
trigger5 = StateNo = 400
trigger5 = MoveHit
trigger6 = StateNo = 410
trigger6 = MoveHit
trigger6 = P2BodyDist X < 60

;---------------------------------------------------------------------------
;Lie Down Gosu Slash
[State -1, Lie Down Gosu Slash]
type = ChangeState
value = 330
triggerall = !IsHelper
triggerall = command = "holdfwd"
triggerall = command = "holddown"
triggerall = statetype != A
triggerall = stateno != 100
triggerall = p2StateType = L
triggerall = p2dist x < 180
triggerall = ctrl
trigger1 = command = "x"
trigger2 = command = "y"
trigger3 = command = "z"

;---------------------------------------------------------------------------
;Dodge Fwd 1
[State -1, Dodge Fwd 1]
type = ChangeState
value = 510
triggerall = !IsHelper
triggerall = p2bodydist x < 30
triggerall = p2StateType != A
triggerall = !numHelper(511)
trigger1 = command = "holdfwd"
trigger1 = command = "b"
trigger1 = statetype = S
trigger1 = ctrl
trigger1 = stateno != 100

;Dodge
[State -1, Dodge]
type = ChangeState
value = 500
triggerall = !IsHelper
trigger1 = command = "b"
trigger1 = statetype != A
trigger1 = ctrl
trigger1 = stateno != [100,102]

;---------------------------------------------------------------------------
;Throw
[State -1, Throw]
type = ChangeState
value = 800
triggerall = !IsHelper
triggerall = command = "z"
triggerall = statetype = S
triggerall = p2bodydist x < 30
triggerall = ctrl
triggerall = stateno != [100,102]
triggerall = P2MoveType != H
triggerall = P2StateType != A
trigger1 = command = "holdfwd"
trigger2 = command = "holdback"

;---------------------------------------------------------------------------
;Air Weak Slash
[State -1, Air Weak Slash]
type = ChangeState
value = 600
triggerall = !IsHelper
triggerall = command = "x"
triggerall = statetype = A
trigger1 = ctrl
trigger2 = StateNo = 45

;Air Medium Slash
[State -1, Air Medium Slash]
type = ChangeState
value = 610
triggerall = !IsHelper
triggerall = command = "y"
triggerall = statetype = A
trigger1 = ctrl
trigger2 = StateNo = 45

;Air Gosu Slash
[State -1, Air Gosu Slash]
type = ChangeState
value = 620
triggerall = !IsHelper
triggerall = command = "z"
triggerall = statetype = A
trigger1 = ctrl
trigger2 = StateNo = 45

;Air Kick
[State -1, Air Kick]
type = ChangeState
value = 630
triggerall = !IsHelper
triggerall = command = "a"
triggerall = statetype = A
trigger1 = ctrl
trigger2 = StateNo = 45

;---------------------------------------------------------------------------
;Crouch Weak Slash
[State -1, Crouch Weak Slash]
type = ChangeState
value = 400
triggerall = !IsHelper
triggerall = command = "x"
triggerall = statetype = C
trigger1 = ctrl

;Crouch Medium Slash
[State -1, Crouch Medium Slash]
type = ChangeState
value = 410
triggerall = !IsHelper
triggerall = command = "y"
triggerall = statetype = C
trigger1 = ctrl

;Crouch Gosu Slash
[State -1, Crouch Gosu Slash]
type = ChangeState
value = 420
triggerall = !IsHelper
triggerall = command = "z"
triggerall = statetype = C
trigger1 = ctrl

;Crouch Strong Kick
[State -1, Crouch Strong Kick]
type = ChangeState
value = 440
triggerall = !IsHelper
triggerall = command = "a"
triggerall = command = "holdfwd"
triggerall = statetype = C
trigger1 = ctrl

;Crouch Kick
[State -1, Crouch Kick]
type = ChangeState
value = 430
triggerall = !IsHelper
triggerall = command = "a"
triggerall = statetype = C
trigger1 = ctrl

;---------------------------------------------------------------------------
;Running Gosu Slash
[State -1, Running Gosu Slash]
type = ChangeState
value = 320
triggerall = !IsHelper
triggerall = command = "z"
triggerall = statetype = S
trigger1 = stateno = 100

;Running Medium Slash
[State -1, Running Medium Slash]
type = ChangeState
value = 310
triggerall = !IsHelper
triggerall = command = "y"
triggerall = statetype = S
trigger1 = stateno = 100

;Running Kick
[State -1, Running Kick]
type = ChangeState
value = 300
triggerall = !IsHelper
triggerall = command = "a"
triggerall = statetype = S
trigger1 = stateno = 100

;---------------------------------------------------------------------------
;Gosu Slash de perto
[State -1, Gosu Slash de perto]
type = ChangeState
value = 250
triggerall = !IsHelper
triggerall = command = "z"
triggerall = statetype = S
triggerall = p2bodydist x < 55
trigger1 = ctrl
trigger1 = stateno != [100,102]
trigger2 = StateNo = 500
trigger2 = AnimElemNo(0) > 3

;Gosu Slash
[State -1, Gosu Slash]
type = ChangeState
value = 240
triggerall = !IsHelper
triggerall = command = "z"
triggerall = statetype = S
trigger1 = ctrl
trigger1 = stateno != [100,102]
trigger2 = StateNo = 500
trigger2 = AnimElemNo(0) > 3

;---------------------------------------------------------------------------
;Medium Slash de perto
[State -1, Medium Slash de perto]
type = ChangeState
value = 230
triggerall = !IsHelper
triggerall = command = "y"
triggerall = statetype = S
triggerall = p2bodydist x < 45
trigger1 = ctrl
trigger1 = stateno != [100,102]
trigger2 = StateNo = 500
trigger2 = AnimElemNo(0) > 3

;Medium Slash
[State -1, Medium Slash]
type = ChangeState
value = 220
triggerall = !IsHelper
triggerall = command = "y"
triggerall = statetype = S
trigger1 = ctrl
trigger1 = stateno != [100,102]
trigger2 = StateNo = 500
trigger2 = AnimElemNo(0) > 3

;---------------------------------------------------------------------------
;Weak Slash de perto
[State -1, Weak Slash de perto]
type = ChangeState
value = 210
triggerall = !IsHelper
triggerall = command = "x"
triggerall = statetype = S
triggerall = p2bodydist x < 45
trigger1 = ctrl
trigger1 = stateno != [100,102]
trigger2 = StateNo = 500
trigger2 = AnimElemNo(0) > 3

;Weak e Run Weak Slash
[State -1, Weak Slash]
type = ChangeState
value = 200
triggerall = !IsHelper
triggerall = command = "x"
triggerall = statetype = S
trigger1 = ctrl
trigger2 = stateno = 100
trigger3 = StateNo = 500
trigger3 = AnimElemNo(0) > 3

;---------------------------------------------------------------------------
;Kick Low
[State -1, Kick Low]
type = ChangeState
value = 270
triggerall = !IsHelper
triggerall = command = "holdfwd"
triggerall = command = "a"
triggerall = statetype = S
trigger1 = ctrl
trigger1 = StateNo != [100,102]
trigger2 = StateNo = 500
trigger2 = AnimElemNo(0) > 3

;Kick
[State -1, Kick]
type = ChangeState
value = 260
triggerall = !IsHelper
triggerall = command = "a"
triggerall = statetype = S
trigger1 = ctrl
trigger1 = stateno != [100,102]
trigger2 = StateNo = 500
trigger2 = AnimElemNo(0) > 3


;===========================================================================
;---------------------------------------------------------------------------
;Taunt
[State -1, Taunt]
type = ChangeState
value = 195
triggerall = !IsHelper
trigger1 = command = "start"
trigger1 = statetype = S
trigger1 = ctrl
trigger1 = stateno != [100,102]

;---------------------------------------------------------------------------
;Run Fwd
[State -1, Run Fwd]
type = ChangeState
value = 100
triggerall = !IsHelper
trigger1 = command = "FF"
trigger1 = statetype = S
trigger1 = ctrl
trigger1 = stateno != [100,102]

;---------------------------------------------------------------------------
;Run Back
[State -1, Run Back]
type = ChangeState
value = 105
triggerall = !IsHelper
trigger1 = command = "BB"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Roll Fwd
[State -1, Roll Fwd]
type = ChangeState
value = 350
triggerall = !IsHelper
trigger1 = command = "holdfwd"
trigger1 = alive
trigger1 = stateno = 5110

;---------------------------------------------------------------------------
;Roll Back
[State -1, Roll Back]
type = ChangeState
value = 355
triggerall = !IsHelper
trigger1 = command = "holdback"
trigger1 = alive
trigger1 = stateno = 5110

;---------------------------------------------------------------------------
;Get Up
[State -1, Get Up]
type = ChangeState
value = 5120
triggerall = !IsHelper
trigger1 = command = "holdup"
trigger1 = alive
trigger1 = stateno = 5110

;---------------------------------------------------------------------------
;Jump Wall .. Wall Jump
[State -1, Jump Wall]
type = ChangeState
value = 45
triggerall = !IsHelper
triggerall = statetype = A
triggerall = ctrl
triggerall = pos y < -const(movement.airjump.height)
triggerall = prevstateno != 45
trigger1 = command = "holdfwd"
trigger1 = command != "holdback"
trigger1 = BackEdgeBodyDist < 20
trigger1 = vel x <= 0
trigger2 = command = "holdback"
trigger2 = command != "holdfwd"
trigger2 = FrontEdgeBodyDist < 20
trigger2 = vel x >= 0

[State -1, Jump Wall]
type = ChangeState
value = 45
triggerall = !IsHelper
triggerall = statetype = A
triggerall = ctrl
triggerall = pos y < -30
triggerall = pos y > -180
triggerall = var(30) = 10001
trigger1 = command = "up"
trigger1 = time > 10

;===========================================================================
;------------------------------- Poppy
;---------------------------------------------------------------------------
[State -1, debug]
ignorehitpause = 1
trigger1 = IsHelper(8000)
type = DisplayToClipboard
text = "parentdist = %f, v0 = %d, parentLife = %d"
params = ParentDist X, Var(0), (Parent, Life)

[State -1, anti-bug]
type     = ChangeState
triggerall = IsHelper(8000)
trigger1 = StateNo != [8000,8999]
value = 8000
ctrl = 0

[State -1, Var(3) unset]
type     = VarSet
triggerall = IsHelper(8000)
trigger1 = Var(3)
var(3)   = 0

[State -1, Var(3) set]
type     = VarSet
triggerall = IsHelper(8000)
triggerall = !Var(3)
triggerall = RoundState = 2
trigger1 = Parent, MoveType = A
trigger1 = Parent, StateNo != 800
trigger2 = Parent, MoveType = H
var(3)   = 1 + Parent, MoveType = H

[State -1, Var(2) normal]
type     = VarSet
trigger1 = IsHelper(8000)
trigger1 = !(Parent, Anim = 804 && Parent, Stateno = 800)
var(2)   = Parent, Facing

[State -1, Var(2) 800]
type     = VarSet
trigger1 = IsHelper(8000)
trigger1 = (Parent, Anim = 804 && Parent, Stateno = 800)
var(2)   = Parent, Facing * -1

[State -1, Var(1) normal]
type     = VarSet
trigger1 = IsHelper(8000)
trigger1 = Parent, StateNo != 510
var(1)   = Floor(ParentDist X)

[State -1, Var(1) 510]
type     = VarSet
trigger1 = IsHelper(8000)
trigger1 = Parent, Stateno = 510
var(1)   = Floor(Abs(Helper(511), ScreenPos X - ScreenPos X))

[State -1, teste]
type     = AfterImage
trigger1 = IsHelper(8000)
trigger1 = 0;gametime%300 = 0
time = 300
paladd = 80,-20,-50
palbright = 20,0,0 
palcontrast = 400,200,200

[State -1, teste]
type     = PalFX
trigger1 = IsHelper(8000)
trigger1 = 0
time = 2
add = 80,-20,-50
mul = 400,100,100










;;;;;;;;;;;;